;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                        ;;;
;;;  file:   EXT_DEL.lsp (lanciare con ED)                                 ;;;
;;;  data:   24/03/2008                                                    ;;;
;;;  note:   ELIMINA LE ENTITA' ESTERNE AD UNA POLILINEA                   ;;;
;;;  aggiornamento: 26/03/2008 (modifica metodo di cancellazione)          ;;;
;;;                                                                        ;;;
;;;  autore: Gian Paolo Cattaneo                                           ;;;
;;;                                                                        ;;;
;;;  Il programma chiede di selezionare una polilinea di contorno e        ;;;
;;;  gli oggetti da trattare.                                              ;;;
;;;                                                                        ;;;
;;;  Questi vengono mantenuti se interni al contorno, tagliati se lo       ;;;
;;;  attraversano, ed eliminati se esterni.                                ;;;
;;;                                                                        ;;;
;;;  La polilinea di contorno NON deve contenere segmenti di arco e        ;;;
;;;  pu anche non essere chiusa in quanto il programma elabora gli        ;;;
;;;  oggetti da tagliare/eliminare come se questa lo fosse.                ;;;
;;;                                                                        ;;;
;;;  Le entit con tipolinea non continua potrebbero non essere catturate  ;;;
;;;  dalla selezione se lo spazio tra i tratti (penna sollevata) fosse     ;;;
;;;  a cavallo della polilinea di contorno.                                ;;;
;;;                                                                        ;;;
;;;  In base all'esperienza maturata dall'utilizzo e alle tipologie di     ;;;
;;;  disegno si pu operare sul numero delle iterazioni (default 4)        ;;;
;;;  per la cattura delle stesse, anche se  preferibile non aumentare     ;;;
;;;  di molto tale valore per evitare blocchi alla routine dovuti,         ;;;
;;;  in seguito alla variazione di zoom, alla cattura di oggetti non       ;;;
;;;  pi visualizzati.                                                     ;;;
;;;  Modificare quindi, nel caso, il valore nella seguente stringa ad      ;;;
;;;  inizio file:                                                          ;;;
;;;                      (setq ITERAZIONI 4)                               ;;;
;;;                                                                        ;;;
;;;                                                                        ;;;
;;;  Questo NON  un programma perfetto, chiunque pu modificarlo per      ;;;
;;;  adattarlo alle proprie esigenze e apportare le migliorie che          ;;;
;;;  ritiene pi opportune.                                                ;;;
;;;                                                                        ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



(defun C:ED ( / PL1 pe TUTTO of pol vert MSG vert tipoPL DE v1 v2 EDM)


    (setq ITERAZIONI 4)

    (setq olderr  *error*  *error* myerror)
    (setq os (getvar "osmode"))
    (setvar "osmode" 0)
    (setq EDM (getvar "edgemode"))
    (setvar "edgemode" 0)
    
    (command "UCS" "_G" "")

    (setq p1 nil  p2 nil  p3 nil  p4 nil  p5 nil  p6 nil  p7 nil
	  p8 nil  p9 nil p10 nil  p11 nil  p12 nil  p13 nil p14 nil
	  p15 nil  p16 nil  p17 nil  p18 nil  p19 nil  p20 nil  p21 nil
	  p22 nil  p23 nil  p24 nil  p25 nil  p26 nil  p27 nil  p28 nil
	  p29 nil p30 nil
	  vert 1
	  tipoPL 0
	  of 0.02     ;valore OFFSET per plinea comando Taglia)
          DE 10000)
	  
	  
    (prompt "\n.  ")
    (prompt "\n.  ")
    (prompt "\n.  ")
    (prompt "\n.  ")
    (prompt "\nSELEZIONARE LA POLILINEA DI CONTORNO")
    (setq PL1 (entsel))
    
    (CONTROLLO)
 
    (FINESTRA_Z)

    (if (> (distance v1 v2) 1000)
	(progn
	    (setq of 0.04)
	    (setq DE 100000)
	)
    )
    (if (> (distance v1 v2) 10000)
	(progn
	    (setq of 0.8)
	    (setq DE 1000000)
	)
    )
    (if (> (distance v1 v2) 100000)
	(progn
	    (setq of 8)
	    (setq DE 10000000)
	)
    )
    
    (prompt "\n.  ")
    (prompt "\n.  ")
    (prompt "\n.  ")
    (prompt "\n.  ")
    (prompt "\nSELEZIONARE GLI OGGETTI DA TRATTARE (interni ed esterni al contorno)")
    (setq TUTTO (ssget))
    (if (= TUTTO nil) (exit))

    (if (/= (cdr (assoc 70 (entget (car PL1)))) 1)   ;;;chiude la Polilinea se aperta
	(progn
	    (command "_pedit" PL1 "_C" "")
	    (setq tipoPL "A")
	)
    )

    (setq pe (polar (cadr PL1) pi DE))   ;punto esterno al contorno
    (command "_OFFSET" of PL1 pe "")
    (setq pol (entlast))

    ;(command "_ZOOM" "_O" PL1 "" )  ;zoom oggetto (versione 2006 e successive)

    (command "_ZOOM" "_W" v1 v2 )    ;zoom ricavato da FINESTRA_Z (per vers. ante/2006)
    (command "_ZOOM" "0.8x")
    
;;;;;;;;;;;;;;;;; calcolo punti POLYLINE ;;;;;;;;;;;;;;;;;;;;;;  

    (If (= (Cdr (Assoc 0 (Entget pol))) "POLYLINE")
	(Progn
	    (command "_ERASE" TUTTO "_R" PL1 "_CP" )      ;inizio comando _ERASE
	    (setq rrr 0)
	    (Setq Pol-Princ (Entget Pol))
	    (Setq Vertice (Entnext Pol))                 ;nome polilinea selezionata
	    (Setq Vertc (Entget Vertice))

	    (While (/= (Cdr (Assoc 0 Vertc)) "SEQEND")   ;CONTA IL NUMERO DEI VERTICI
		(Setq X (Car (Cdr (Assoc 10 Vertc))))    ;coordinate vertice
		(Setq Y (Cadr (Cdr (Assoc 10 Vertc))))   ;
		(setq p1 (list x y))
		(if (= rrr 0) (setq pu p1))
		(command P1)
		(setq vert (1+ vert))
		(Setq Vertice (Entnext Vertice))         
		(Setq Vertc (Entget Vertice))
		(setq rrr 1)
	    )
	    (command pu "" "")                           ;fine comando _ERASE

	    (repeat ITERAZIONI	    
		(command "_TRIM" PL1 "" "_F")            ;inizio comando TRIM
		(setq rrr 0)
		(Setq Pol-Princ (Entget Pol))
		(Setq Vertice (Entnext Pol))             
		(Setq Vertc (Entget Vertice))
		(While (/= (Cdr (Assoc 0 Vertc)) "SEQEND")
		    (Setq X (Car (Cdr (Assoc 10 Vertc))))    
		    (Setq Y (Cadr (Cdr (Assoc 10 Vertc))))    
		    (setq p1 (list x y))
		    (if (= rrr 0) (setq pu p1))
		    (command P1)
		    (setq vert (1+ vert))
		    (Setq Vertice (Entnext Vertice))         
		    (Setq Vertc (Entget Vertice))
		    (setq rrr 1)
	        )
		(command pu "" "")                       ;fine comando TRIM

		(setq of (* of 2.6))
		(command "_OFFSET" of PL1 pe "")
		(setq pol1 (entlast))
		(command "_ERASE" pol "")
		(setq pol pol1)
		(command "_ZOOM" "0.96x")
	    )
	)
    )
    
 
;;;;;;;;;;;;;;; calcolo punti LWPOLYLINE ;;;;;;;;;;;;;;;;;;;;;; 

    (If (= (Cdr (Assoc 0 (Entget (car PL1)))) "LWPOLYLINE")
	(Progn

	    (command "_ERASE" TUTTO "_R" PL1 "_CP" )        
	    (setq rrr 0)
	    (Setq I 0)
	    (Repeat (Length (setq lwp (entget (car PL1))))
		(Setq Lwele (Nth I Lwp))
		(If (= (Car Lwele) 10)
		    (Progn
			(Setq X (Cadr Lwele))
			(Setq Y (Caddr Lwele))
			(setq p1 (list x y))
			(if (= rrr 0) (setq pu p1))
			(command P1)
			(setq rrr 1)
		    )
		)
		(Setq I (+ I 1))
	    )
	    (command pu "" "")                

            (repeat ITERAZIONI	                                 
		(command "_TRIM" PL1 "" "_F")            ;inizio comando TRIM        
		(setq rrr 0)
		(Setq I 0)
		(Repeat (Length (setq lwp (entget pol)))
		    (Setq Lwele (Nth I Lwp))
		    (If (= (Car Lwele) 10)
			(Progn
			    (Setq X (Cadr Lwele))
			    (Setq Y (Caddr Lwele))
			    (setq p1 (list x y))
			    (if (= rrr 0) (setq pu p1))
			    (command P1)
			    (setq rrr 1)
			)
		    )
		    (Setq I (+ I 1))
		)
		(command pu "" "")                       ;fine comando TRIM

		(setq of (* of 2.6))
		(command "_OFFSET" of PL1 pe "")
		(setq pol1 (entlast))
		(command "_ERASE" pol "")
		(setq pol pol1)
		(command "_ZOOM" "0.96x")
            )
	)
    )
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    
    (command "_ERASE" pol "")
    (if (= tipoPL "A") (command "_pedit" PL1 "_O" ""))   ;riapre la polilinea  

    (command "_ZOOM" "_P")
    (command "_ZOOM" "_P")
    (command "UCS" "_P" "")
    (setvar "osmode" os)
    (setvar "edgemode" EDM)
    
    (prompt "\n.  ")
    (prompt "\n.  ")
    (prompt "\n.  ")
    (princ)

    
);defun



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;; controllo tipo entit CONTORNO (Poly o LWPoly)  ;;;;;;;;;;;;;;;;

(defun CONTROLLO ( /)
    (setq tipoE (Cdr (Assoc 0 (Entget (car PL1)))))
    (if (and (/= tipoE "LWPOLYLINE") (/= tipoE "POLYLINE"))
	(progn
	    (setq MSG (strcat "L'oggetto selezionato NON  una Polilinea "
		      "\n    -------------------------------------------"
		      "\n          Il programma si interrompe ")) 
	    (alert MSG)
	    (exit)
	)
    )
)


;;;;;;;;;;;;; calcolo punti zoom per versione 2005 e anteriori ;;;;;;;;;;;;;;
;;;;;;;;;;;;;  in quanto sprovviste del comando ZOOM OGGETTO   ;;;;;;;;;;;;;;

(defun FINESTRA_Z ( /)
    (setq vvv 0)
    (If (= (Cdr (Assoc 0 (Entget (car PL1)))) "POLYLINE")
	(Progn
	    (Setq Pol-Princ (Entget (car PL1)))
	    (Setq Vertice (Entnext (car PL1)))               
	    (Setq Vertc (Entget Vertice))
	    (While (/= (Cdr (Assoc 0 Vertc)) "SEQEND") 
		(Setq X (Car (Cdr (Assoc 10 Vertc))))    
		(Setq Y (Cadr (Cdr (Assoc 10 Vertc))))
		(if (= vvv 0)
		    (progn
			(setq xmin X
			      xmax X
			      ymin Y
			      ymax Y
			)
	             )
		)
		(setq xmin (min xmin x))
		(setq xmax (max xmax x))
		(setq ymin (min ymin y))
		(setq ymax (max ymax y))
		(Setq Vertice (Entnext Vertice))         
		(Setq Vertc (Entget Vertice))
		(setq vvv 1)
	    )
            (setq v1 (list xmin ymin))
	    (setq v2 (list xmax ymax))
	)
    )

    (If (= (Cdr (Assoc 0 (Entget (car PL1)))) "LWPOLYLINE")
	(Progn
	    (Setq I 0)
	    (Repeat (Length (setq lwp (entget (car PL1))))
		(Setq Lwele (Nth I Lwp))
		(If (= (Car Lwele) 10)
		    (Progn
			(Setq X (Cadr Lwele))
			(Setq Y (Caddr Lwele))
			(if (= vvv 0)
			    (progn
				(setq xmin X
				      xmax X
				      ymin Y
				      ymax Y
      			        )
	                    )
		        )
			(setq xmin (min xmin x))
			(setq xmax (max xmax x))
			(setq ymin (min ymin y))
			(setq ymax (max ymax y))
			(setq vvv 1)
	            )
		)
		(Setq I (+ I 1))
	    )
	    (setq v1 (list xmin ymin))
	    (setq v2 (list xmax ymax))
	)
    )
)

;;;;;;;;;;;;;;;;;;;;;;;; gestione errori ;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun myerror (s)
    (if (/= s "Function cancelled")
	(princ (strcat "\nError: " s))
    )
    (command "UCS" "_P" "")
    (setvar "osmode" os)
    (setvar "edgemode" EDM)
    (princ)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(prompt "\n.  ")
(prompt "\n.  ")
(prompt "\n.  ")
(princ "\nDigitare ED per lanciare il lisp")
(princ)



